# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`yapgp`](#yapgp): Main class, ensures dependencies are installed.

### Resource types

* [`pgp_key`](#pgp_key): This type provides Puppet with the capability to manage PGP keys

### Functions

* [`export_pgp_key`](#export_pgp_key): Returns an armored export of the given key.

## Classes

### <a name="yapgp"></a>`yapgp`

Ensures all the yapgp module's dependencies are installed.

#### Examples

##### 

```puppet
include yapgp
```

## Resource types

### <a name="pgp_key"></a>`pgp_key`

This type provides Puppet with the capability to manage PGP keys

#### Examples

##### Basic usage

```puppet
pgp_key { 'Tails sysadmins':
  fp     => 'D113CB6D5131D34BA5F0FE9E70F4F03116525F43',
  ensure => present,
  trust  => 4,
  user   => root,
}
```

#### Properties

The following properties are available in the `pgp_key` type.

##### `ensure`

Valid values: `present`, `absent`

Ensure the key is present or absent

Default value: `present`

#### Parameters

The following parameters are available in the `pgp_key` type.

* [`fp`](#fp)
* [`name`](#name)
* [`provider`](#provider)
* [`source`](#source)
* [`trust`](#trust)
* [`user`](#user)

##### <a name="fp"></a>`fp`

Valid values: `%r{\A(0x)?[0-9a-fA-F]{40}\Z}`

The fingerprint of the key you want to manage, should be the full 40-digit key fingerprint.

##### <a name="name"></a>`name`

namevar

The unique name of this resource.

##### <a name="provider"></a>`provider`

The specific backend to use for this `pgp_key` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

##### <a name="source"></a>`source`

Where to retrieve the key from (URI or local file)

##### <a name="trust"></a>`trust`

Valid values: `%r{\A[1-5]\Z}`

The trustlevel of the key you want to manage, should be an integer between 1 and 5.

Default value: `1`

##### <a name="user"></a>`user`

The user for whom you want to manage the key.

Default value: `root`

## Functions

### <a name="export_pgp_key"></a>`export_pgp_key`

Type: Ruby 3.x API

Takes the key fingerprint as first argument.
The second argument, the username to whom the keyring belongs, is optional.

#### `export_pgp_key()`

Takes the key fingerprint as first argument.
The second argument, the username to whom the keyring belongs, is optional.

Returns: `Variant[String,Boolean]` Returns an armored key as string or `false` if the given key cannot be exported.

